;; delay.as for 4MHz PIC 16F84

l_delay_1s_d:		EQU		0x30
l_delay_500ms_d:	EQU		0x31
l_delay_100ms_d:	EQU		0x32
l_delay_50ms_d:		EQU		0x33
l_delay_10ms_d:		EQU		0x34
l_delay_5ms_d:		EQU		0x35
l_delay_1ms_d:		EQU		0x36
l_delay_100us_d:	EQU		0x37


	

delay_1s:	
	MOVLW	10
	MOVWF	l_delay_1s_d
__delay_1s_0:
	CALL	delay_100ms
	DECFSZ	l_delay_1s_d, F
	GOTO	__delay_1s_0
	RETURN

	

delay_500ms:	
	MOVLW	50
	MOVWF	l_delay_500ms_d
__delay_500ms_0:
	CALL	delay_10ms
	DECFSZ	l_delay_500ms_d, F
	GOTO	__delay_500ms_0
	RETURN


	
delay_100ms:	
	MOVLW	10
	MOVWF	l_delay_100ms_d
__delay_100ms_0:
	CALL	delay_10ms
	DECFSZ	l_delay_100ms_d, F
	GOTO	__delay_100ms_0
	RETURN

	

delay_50ms:	
	MOVLW	50
	MOVWF	l_delay_50ms_d
__delay_50ms_0:
	CALL	delay_1ms
	DECFSZ	l_delay_50ms_d, F
	GOTO	__delay_50ms_0
	RETURN


delay_10ms:	
	MOVLW	10
	MOVWF	l_delay_10ms_d
__delay_10ms_0:
	CALL	delay_1ms
	DECFSZ	l_delay_10ms_d, F
	GOTO	__delay_10ms_0
	RETURN


delay_5ms:	
	MOVLW	50
	MOVWF	l_delay_5ms_d
__delay_5ms_0:
	CALL	delay_100us	
	DECFSZ	l_delay_5ms_d, F
	GOTO	__delay_5ms_0
	RETURN

	
delay_1ms:	
	MOVLW	10
	MOVWF	l_delay_1ms_d
__delay_1ms_0:
	CALL	delay_100us	
	DECFSZ	l_delay_1ms_d, F
	GOTO	__delay_1ms_0
	RETURN

	
;;; 4.0M Hz PIC
delay_100us:	
	MOVLW	31
	MOVWF	l_delay_100us_d
	NOP
	NOP
__delay_100us_0:
	DECFSZ	l_delay_100us_d, F
	GOTO	__delay_100us_0
	NOP			; X
	NOP			; X
	RETURN

	;;; (setq n 31)
	;;; (setq frq 4.0)
	;;; (defun cycles () (+ 1 1 1 1 (+ (- n 1) 2) (* 2 (- n 1)) 1 1 2))
	;;; (defun d () (/ (* 4 (cycles)) frq))
	;;; (cycles)
	;;; (d)
